'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTinyVirtualList = require('react-tiny-virtual-list');

var _reactTinyVirtualList2 = _interopRequireDefault(_reactTinyVirtualList);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactScrollbarSize = require('react-scrollbar-size');

var _reactScrollbarSize2 = _interopRequireDefault(_reactScrollbarSize);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactContainerDimensions = require('react-container-dimensions');

var _GridCell = require('./GridCell');

var _GridCell2 = _interopRequireDefault(_GridCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GridRow = (0, _mobxReact.observer)(_class = function (_React$Component) {
  _inherits(GridRow, _React$Component);

  function GridRow(props) {
    _classCallCheck(this, GridRow);

    var _this = _possibleConstructorReturn(this, (GridRow.__proto__ || Object.getPrototypeOf(GridRow)).call(this, props));

    (0, _reactAutobind2.default)(_this);return _this;
  }

  _createClass(GridRow, [{
    key: 'render',
    value: function render() {

      var selRow = false;
      if (this.props.GridStore.cursor.y === this.props.index) {
        selRow = true;
      }

      var cellArray = [];
      var marginOffset = Math.floor(-1 * this.props.borderWide);

      var sharedBaseStyleLeftCol = _extends({}, this.props.styleHeader, {
        width: this.props.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        borderWidth: this.props.borderWide,
        padding: (this.props.padWide || 0) + 'px',
        borderTop: '0px',
        height: this.props.cellHigh,
        display: 'inline-block',
        outline: outline,
        overflow: 'hidden'
      });
      var sharedBaseStyleLeftColIn = {
        width: this.props.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        backgroundColor: '#fffef4',
        borderWidth: this.props.borderWide,
        padding: (this.props.padWide || 0) + 'px',
        borderTop: '0px',
        height: this.props.cellHigh,
        display: 'inline-block',
        outline: outline,
        overflow: 'hidden'
      };

      if (this.props.rowHeaderList && this.props.rowHeaderList.length > 0) {
        // if pivoted or rowHeadered, make the row headers have header style
        sharedBaseStyleLeftCol.backgroundColor = '#F3F3F3';
        sharedBaseStyleLeftCol.textAlign = 'center';
      }

      var sharedBaseStyleInput = { width: this.props.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        borderWidth: this.props.borderWide,
        backgroundColor: '#fffef4',
        padding: (this.props.padWide || 0) + 'px',
        borderTop: '0px',
        height: this.props.cellHigh,
        display: 'inline-block',
        outline: outline,
        marginLeft: marginOffset,
        overflow: 'hidden'
      };
      var sharedBaseStyle2 = { width: this.props.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        borderWidth: this.props.borderWide,
        padding: (this.props.padWide || 0) + 'px',
        borderTop: '0px',
        height: this.props.cellHigh,
        display: 'inline-block',
        outline: outline,
        marginLeft: marginOffset,
        overflow: 'hidden'
      };

      var cellStyleFirst = Object.assign(sharedBaseStyleLeftCol, this.props.styleCell || {});
      var cellStyleLocal = Object.assign(sharedBaseStyle2, this.props.styleCell || {});

      var inputStyleFirst = Object.assign(sharedBaseStyleLeftColIn, this.props.styleInput || {});
      var inputStyleLocal = Object.assign(sharedBaseStyleInput, this.props.styleInput || {});
      inputStyleFirst.marginTop = '-4';
      inputStyleLocal.marginTop = '-4';

      var forceObjKey = null; // used for pivoted data only

      var columnCount = this.props.GridStore.cursor.maxX + 1;
      if (this.props.pivotOn) {
        columnCount = this.props.data.length;
      }
      var isFirst = true;
      for (var ctr = -1; ctr < columnCount; ctr++) {
        var borderColor = 'black';
        var zIndex = 0;
        var outline = '';

        cellStyleLocal.marginLeft = marginOffset + 'px';

        // row header / pivot work
        if (ctr === -1) {
          if (this.props.rowHeaderList && this.props.rowHeaderList.length > this.props.index) {
            forceObjKey = this.props.rowHeaderList[this.props.index];

            var titleText = this.props.rowHeaderList[this.props.index]; // what key am I on?
            if (this.props.GridStore.colDefList[titleText]) {
              // is there a colDef that uses this key?
              titleText = this.props.GridStore.colDefList[titleText].title || titleText; // if there is a title for the colDef use it, or just stick with thekey
            }

            cellArray.push(_react2.default.createElement(_GridCell2.default, {
              key: this.props.index + '-RH',
              id: this.props.index + '-RH',
              x: ctr,
              y: this.props.index,
              forceNoEdit: true,
              styleInput: inputStyleFirst,
              styleCell: cellStyleFirst,
              borderWide: this.props.borderWide,
              padWide: this.props.padWide,
              GridStore: this.props.GridStore,
              cellData: titleText,
              onChange: this.props.onChange
            }));
            isFirst = false;
          }
        } else {

          var cellData = '';
          if (this.props.pivotOn) {
            cellData = this.props.data[ctr][forceObjKey];
          } else {
            cellData = this.props.data[this.props.index][this.props.keyNames[ctr]];
          }

          cellArray.push(_react2.default.createElement(_GridCell2.default, {
            key: this.props.index + '-' + ctr,
            id: this.props.index + '-' + ctr,
            x: ctr,
            y: this.props.index,
            objKey: forceObjKey || this.props.keyNames[ctr],
            styleInput: isFirst ? inputStyleFirst : inputStyleLocal,
            styleCell: isFirst ? cellStyleFirst : cellStyleLocal,
            borderWide: this.props.borderWide,
            padWide: this.props.padWide,
            GridStore: this.props.GridStore,
            cellData: cellData,
            onChange: this.props.onChange
          }));
          isFirst = false;
        }
      }

      return _react2.default.createElement(
        'div',
        { style: { width: this.props.rowWide,
            height: this.props.rowHigh } },
        cellArray
      );
    }
  }]);

  return GridRow;
}(_react2.default.Component)) || _class;

exports.default = GridRow;
module.exports = exports['default'];